Subject: Re: Odd off-by-one dirty buffers and checkpoint buffers written

From: Nathan Bossart <[email-masked]>
Date: Tue, 19 Apr 2022 16:36:51 -0700

On Tue, Apr 19, 2022 at 04:21:21PM -0700, David G. Johnston wrote:
> I've done this four times in a row and while the number of dirty buffers
> shown each time vary (see below) I see that "wrote N buffers" is always
> exactly one more than the total count of dirty buffers.  I'm just curious
> if anyone has a quick answer for this unusual correspondence.

I see that SlruInternalWritePage() increments ckpt_bufs_written, so my
first guess would be that it's due to something like CheckPointCLOG().

-- 
Nathan Bossart
Amazon Web Services: https://aws.amazon.com